Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 76)
@@ -0,0 +1,106 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_Parameters_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Parameters.h"
+#include <math.h>
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : const uint32_t    _size_read_queue         ;
+  public : const uint32_t    _size_reservation_station;
+  public : const uint32_t    _nb_context              ;
+  public : const uint32_t    _nb_front_end            ;
+  public : const uint32_t    _nb_ooo_engine           ;
+  public : const uint32_t    _nb_packet               ;
+  public : const uint32_t    _size_general_data       ;
+  public : const uint32_t    _size_special_data       ;
+  public : const uint32_t    _nb_general_register     ;
+  public : const uint32_t    _nb_special_register     ;
+  public : const uint32_t    _nb_operation            ;
+  public : const uint32_t    _nb_type                 ;
+  public : const uint32_t    _nb_gpr_write            ;
+  public : const uint32_t    _nb_spr_write            ;
+  public : const uint32_t    _size_store_queue        ;
+  public : const uint32_t    _size_load_queue         ;
+  public : const uint32_t    _nb_inst_retire          ;
+  public : const uint32_t    _nb_bypass_write         ;
+  public : const uint32_t    _nb_bypass_memory        ;
+						      
+  public : const uint32_t    _nb_gpr_read             ;
+  public : const uint32_t    _nb_spr_read             ;    
+  public : const uint32_t    _size_context_id         ;
+  public : const uint32_t    _size_front_end_id       ;
+  public : const uint32_t    _size_ooo_engine_id      ;
+  public : const uint32_t    _size_packet_id          ;
+  public : const uint32_t    _size_general_register   ;
+  public : const uint32_t    _size_special_register   ;
+  public : const uint32_t    _size_operation          ;
+  public : const uint32_t    _size_type               ;
+
+  public : const bool        _have_port_context_id    ;
+  public : const bool        _have_port_front_end_id  ;
+  public : const bool        _have_port_ooo_engine_id ;
+  public : const bool        _have_port_packet_id     ;
+
+  public : morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue         ::Parameters * _param_read_queue;
+  public : morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters * _param_reservation_station;
+
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (uint32_t size_read_queue         ,
+			uint32_t size_reservation_station,
+			uint32_t nb_context              ,
+			uint32_t nb_front_end            ,
+			uint32_t nb_ooo_engine           ,
+			uint32_t nb_packet               ,
+			uint32_t size_general_data       ,
+			uint32_t size_special_data       ,
+			uint32_t nb_general_register     ,
+			uint32_t nb_special_register     ,
+			uint32_t nb_operation            ,
+			uint32_t nb_type                 ,
+			uint32_t nb_gpr_write            ,
+			uint32_t nb_spr_write            ,
+			uint32_t size_store_queue        ,
+			uint32_t size_load_queue         ,
+			uint32_t nb_inst_retire          ,
+			uint32_t nb_bypass_write         ,
+			uint32_t nb_bypass_memory        );
+  public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public :        std::string   msg_error  (void);
+
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::Parameters & x);
+  };
+
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Read_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Read_unit.h	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Read_unit.h	(revision 76)
@@ -0,0 +1,220 @@
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_Read_unit_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_read_unit_read_unit_Read_unit_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#include <iostream>
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+#include "Behavioural/include/Types.h"
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h"
+#ifdef STATISTICS
+#include "Behavioural/include/Stat.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#include "Behavioural/include/Usage.h"
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+
+
+  class Read_unit 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const std::string  _name;
+  protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
+
+#ifdef STATISTICS
+  public    : Stat                           * _stat;
+#endif
+
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // Interface
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ~~~~~[ Interface "read_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_VAL                  ;
+  public    : SC_OUT(Tcontrol_t        )    * out_READ_UNIT_IN_ACK                  ;
+  public    : SC_IN (Tcontext_t        )    *  in_READ_UNIT_IN_CONTEXT_ID           ;
+  public    : SC_IN (Tcontext_t        )    *  in_READ_UNIT_IN_FRONT_END_ID         ;
+  public    : SC_IN (Tcontext_t        )    *  in_READ_UNIT_IN_OOO_ENGINE_ID        ;
+  public    : SC_IN (Tpacket_t         )    *  in_READ_UNIT_IN_PACKET_ID            ;
+  public    : SC_IN (Toperation_t      )    *  in_READ_UNIT_IN_OPERATION            ;
+  public    : SC_IN (Ttype_t           )    *  in_READ_UNIT_IN_TYPE                 ;
+  public    : SC_IN (Tlsq_ptr_t        )    *  in_READ_UNIT_IN_STORE_QUEUE_PTR_WRITE;
+  public    : SC_IN (Tlsq_ptr_t        )    *  in_READ_UNIT_IN_LOAD_QUEUE_PTR_WRITE ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_HAS_IMMEDIAT         ;
+  public    : SC_IN (Tgeneral_data_t   )    *  in_READ_UNIT_IN_IMMEDIAT             ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_READ_RA              ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_READ_UNIT_IN_NUM_REG_RA           ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_READ_RB              ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_READ_UNIT_IN_NUM_REG_RB           ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_READ_RC              ;
+  public    : SC_IN (Tspecial_address_t)    *  in_READ_UNIT_IN_NUM_REG_RC           ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_WRITE_RD             ;
+  public    : SC_IN (Tgeneral_address_t)    *  in_READ_UNIT_IN_NUM_REG_RD           ;
+  public    : SC_IN (Tcontrol_t        )    *  in_READ_UNIT_IN_WRITE_RE             ;
+  public    : SC_IN (Tspecial_address_t)    *  in_READ_UNIT_IN_NUM_REG_RE           ;
+
+    // ~~~~~[ Interface "read_unit_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t        )   ** out_READ_UNIT_OUT_VAL                  ;
+  public    : SC_IN (Tcontrol_t        )   **  in_READ_UNIT_OUT_ACK                  ;
+  public    : SC_OUT(Tcontext_t        )   ** out_READ_UNIT_OUT_CONTEXT_ID           ;
+  public    : SC_OUT(Tcontext_t        )   ** out_READ_UNIT_OUT_FRONT_END_ID         ;
+  public    : SC_OUT(Tcontext_t        )   ** out_READ_UNIT_OUT_OOO_ENGINE_ID        ;
+  public    : SC_OUT(Tpacket_t         )   ** out_READ_UNIT_OUT_PACKET_ID            ;
+  public    : SC_OUT(Toperation_t      )   ** out_READ_UNIT_OUT_OPERATION            ;
+  public    : SC_OUT(Ttype_t           )   ** out_READ_UNIT_OUT_TYPE                 ;
+  public    : SC_OUT(Tlsq_ptr_t        )   ** out_READ_UNIT_OUT_STORE_QUEUE_PTR_WRITE;
+  public    : SC_OUT(Tlsq_ptr_t        )   ** out_READ_UNIT_OUT_LOAD_QUEUE_PTR_WRITE ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_READ_UNIT_OUT_HAS_IMMEDIAT         ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_READ_UNIT_OUT_IMMEDIAT             ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_READ_UNIT_OUT_DATA_RA              ;
+  public    : SC_OUT(Tgeneral_data_t   )   ** out_READ_UNIT_OUT_DATA_RB              ;
+  public    : SC_OUT(Tspecial_data_t   )   ** out_READ_UNIT_OUT_DATA_RC              ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_READ_UNIT_OUT_WRITE_RD             ;
+  public    : SC_OUT(Tgeneral_address_t)   ** out_READ_UNIT_OUT_NUM_REG_RD           ;
+  public    : SC_OUT(Tcontrol_t        )   ** out_READ_UNIT_OUT_WRITE_RE             ;
+  public    : SC_OUT(Tspecial_address_t)   ** out_READ_UNIT_OUT_NUM_REG_RE           ;
+
+    // ~~~~~[ Interface "gpr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t        )   ** out_GPR_READ_VAL          ;
+  public    : SC_IN (Tcontrol_t        )   **  in_GPR_READ_ACK          ;
+  public    : SC_OUT(Tcontext_t        )   ** out_GPR_READ_OOO_ENGINE_ID;
+  public    : SC_OUT(Tgeneral_address_t)   ** out_GPR_READ_NUM_REG      ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_GPR_READ_DATA         ;
+  public    : SC_IN (Tcontrol_t        )   **  in_GPR_READ_DATA_VAL     ;
+
+    // ~~~~~[ Interface "spr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t        )   ** out_SPR_READ_VAL          ;
+  public    : SC_IN (Tcontrol_t        )   **  in_SPR_READ_ACK          ;
+  public    : SC_OUT(Tcontext_t        )   ** out_SPR_READ_OOO_ENGINE_ID;
+  public    : SC_OUT(Tspecial_address_t)   ** out_SPR_READ_NUM_REG      ;
+  public    : SC_IN (Tspecial_data_t   )   **  in_SPR_READ_DATA         ;
+  public    : SC_IN (Tcontrol_t        )   **  in_SPR_READ_DATA_VAL     ;
+
+    // ~~~~~[ Interface "gpr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )   **  in_GPR_WRITE_VAL          ;
+  public    : SC_IN (Tcontext_t        )   **  in_GPR_WRITE_OOO_ENGINE_ID;
+  public    : SC_IN (Tgeneral_address_t)   **  in_GPR_WRITE_NUM_REG      ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_GPR_WRITE_DATA         ;
+
+    // ~~~~~[ Interface "spr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )   **  in_SPR_WRITE_VAL          ;
+  public    : SC_IN (Tcontext_t        )   **  in_SPR_WRITE_OOO_ENGINE_ID;
+  public    : SC_IN (Tspecial_address_t)   **  in_SPR_WRITE_NUM_REG      ;
+  public    : SC_IN (Tspecial_data_t   )   **  in_SPR_WRITE_DATA         ;
+
+    // ~~~~~[ Interface "bypass_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_WRITE_OOO_ENGINE_ID ;
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_GPR_VAL       ;
+  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_WRITE_GPR_NUM_REG   ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_WRITE_GPR_DATA      ;
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_WRITE_SPR_VAL       ;
+  public    : SC_IN (Tspecial_address_t)   **  in_BYPASS_WRITE_SPR_NUM_REG   ;
+  public    : SC_IN (Tspecial_data_t   )   **  in_BYPASS_WRITE_SPR_DATA      ;
+
+    // ~~~~~[ Interface "bypass_memory" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t        )   **  in_BYPASS_MEMORY_VAL          ;
+  public    : SC_IN (Tcontext_t        )   **  in_BYPASS_MEMORY_OOO_ENGINE_ID;
+  public    : SC_IN (Tgeneral_address_t)   **  in_BYPASS_MEMORY_NUM_REG      ;
+  public    : SC_IN (Tgeneral_data_t   )   **  in_BYPASS_MEMORY_DATA         ;
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+  private   : morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue         ::Read_queue          * _component_read_queue;
+  private   : morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Reservation_station * _component_reservation_station;
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#endif
+
+    // -----[ Methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (Read_unit);
+#endif
+  public  :          Read_unit              
+  (
+#ifdef SYSTEMC
+   sc_module_name                                name,
+#else					       
+   std::string                                   name,
+#endif					       
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   Parameters                                  * param,
+   morpheo::behavioural::Tusage_t                usage=USE_ALL
+   );
+  public  :          ~Read_unit             (void);
+					       
+  private : void        allocation                (
+#ifdef STATISTICS
+						   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+						   void
+#endif
+						   );
+  private : void        deallocation              (void);
+					       
+#ifdef SYSTEMC				       
+# if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  public  : void        transition                (void);
+# endif
+#endif					       
+
+#if VHDL				       
+  public  : void        vhdl                      (void);
+#endif					       
+
+#ifdef STATISTICS
+  public  : void        statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
+#endif
+  };
+
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 76)
@@ -0,0 +1,191 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit::Parameters"
+  Parameters::Parameters (uint32_t size_read_queue         ,
+			  uint32_t size_reservation_station,
+			  uint32_t nb_context              ,
+			  uint32_t nb_front_end            ,
+			  uint32_t nb_ooo_engine           ,
+			  uint32_t nb_packet               ,
+			  uint32_t size_general_data       ,
+			  uint32_t size_special_data       ,
+			  uint32_t nb_general_register     ,
+			  uint32_t nb_special_register     ,
+			  uint32_t nb_operation            ,
+			  uint32_t nb_type                 ,
+			  uint32_t nb_gpr_write            ,
+			  uint32_t nb_spr_write            ,
+			  uint32_t size_store_queue        ,
+			  uint32_t size_load_queue         ,
+			  uint32_t nb_inst_retire          ,
+			  uint32_t nb_bypass_write         ,
+			  uint32_t nb_bypass_memory        ):
+    _size_read_queue          (size_read_queue         ),
+    _size_reservation_station (size_reservation_station),
+    _nb_context               (nb_context              ),
+    _nb_front_end             (nb_front_end            ),
+    _nb_ooo_engine            (nb_ooo_engine           ),
+    _nb_packet                (nb_packet               ),
+    _size_general_data        (size_general_data       ),
+    _size_special_data        (size_special_data       ),
+    _nb_general_register      (nb_general_register     ),
+    _nb_special_register      (nb_special_register     ),
+    _nb_operation             (nb_operation            ),
+    _nb_type                  (nb_type                 ),
+    _nb_gpr_write             (nb_gpr_write            ),
+    _nb_spr_write             (nb_spr_write            ),
+    _size_store_queue         (size_store_queue        ),
+    _size_load_queue          (size_load_queue         ),
+    _nb_inst_retire           (nb_inst_retire          ),
+    _nb_bypass_write          (nb_bypass_write         ),
+    _nb_bypass_memory         (nb_bypass_memory        ),
+    
+    _nb_gpr_read              (2),
+    _nb_spr_read              (1),    
+    _size_context_id          (log2(nb_context         )),
+    _size_front_end_id        (log2(nb_front_end       )),
+    _size_ooo_engine_id       (log2(nb_ooo_engine      )),
+    _size_packet_id           (log2(nb_packet          )),
+    _size_general_register    (log2(nb_general_register)),
+    _size_special_register    (log2(nb_special_register)),
+    _size_operation           (log2(nb_operation       )),
+    _size_type                (log2(nb_type            )),
+    
+    _have_port_context_id     (_size_context_id   >0),
+    _have_port_front_end_id   (_size_front_end_id >0),
+    _have_port_ooo_engine_id  (_size_ooo_engine_id>0),
+    _have_port_packet_id      (_size_packet_id    >0)
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    _param_read_queue = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters
+      ( _size_read_queue    
+	,_nb_context         
+	,_nb_front_end       
+	,_nb_ooo_engine
+	,_nb_packet          
+	,_size_general_data  
+	,_size_special_data  
+	,_nb_general_register
+	,_nb_special_register
+	,_nb_operation       
+	,_nb_type            
+	,_nb_gpr_write
+	,_nb_spr_write
+	,_size_store_queue
+	,_size_load_queue 
+	);
+
+    _param_reservation_station = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters
+	(size_reservation_station
+	 ,nb_inst_retire     
+	 ,nb_context         
+	 ,nb_front_end       
+	 ,nb_ooo_engine
+	 ,nb_packet          
+	 ,size_general_data  
+	 ,size_special_data  
+	 ,nb_general_register
+	 ,nb_special_register
+	 ,nb_operation       
+	 ,nb_type            
+	 ,nb_gpr_write
+	 ,nb_spr_write
+	 ,nb_bypass_write 
+	 ,nb_bypass_memory
+	 ,size_store_queue
+	 ,size_load_queue 
+	 );
+
+
+    test();
+
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+  };
+  
+#undef  FUNCTION
+#define FUNCTION "Read_unit::Parameters (copy)"
+  Parameters::Parameters (Parameters & param):
+    _size_read_queue          (param._size_read_queue         ),
+    _size_reservation_station (param._size_reservation_station),
+    _nb_context               (param._nb_context              ),
+    _nb_front_end             (param._nb_front_end            ),
+    _nb_ooo_engine            (param._nb_ooo_engine           ),
+    _nb_packet                (param._nb_packet               ),
+    _size_general_data        (param._size_general_data       ),
+    _size_special_data        (param._size_special_data       ),
+    _nb_general_register      (param._nb_general_register     ),
+    _nb_special_register      (param._nb_special_register     ),
+    _nb_operation             (param._nb_operation            ),
+    _nb_type                  (param._nb_type                 ),
+    _nb_gpr_write             (param._nb_gpr_write            ),
+    _nb_spr_write             (param._nb_spr_write            ),
+    _size_store_queue         (param._size_store_queue        ),
+    _size_load_queue          (param._size_load_queue         ),
+    _nb_inst_retire           (param._nb_inst_retire          ),
+    _nb_bypass_write          (param._nb_bypass_write         ),
+    _nb_bypass_memory         (param._nb_bypass_memory        ),
+
+    _nb_gpr_read              (param._nb_gpr_read             ),
+    _nb_spr_read              (param._nb_spr_read             ),    
+    _size_context_id          (param._size_context_id         ),
+    _size_front_end_id        (param._size_front_end_id       ),
+    _size_ooo_engine_id       (param._size_ooo_engine_id      ),
+    _size_packet_id           (param._size_packet_id          ),
+    _size_general_register    (param._size_general_register   ),
+    _size_special_register    (param._size_special_register   ),
+    _size_operation           (param._size_operation          ),
+    _size_type                (param._size_type               ),
+
+    _have_port_context_id     (param._have_port_context_id    ),
+    _have_port_front_end_id   (param._have_port_front_end_id  ),
+    _have_port_ooo_engine_id  (param._have_port_ooo_engine_id ),
+    _have_port_packet_id      (param._have_port_packet_id     )
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    _param_read_queue          = param._param_read_queue         ;
+    _param_reservation_station = param._param_reservation_station;
+
+    test();
+
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit::~Parameters"
+  Parameters::~Parameters () 
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    delete _param_read_queue;
+    delete _param_reservation_station;
+
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+  };
+
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_msg_error.cpp	(revision 76)
@@ -0,0 +1,41 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit::msg_error"
+  std::string Parameters::msg_error(void)
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    std::string msg = "";
+
+    return msg;
+
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+  };
+
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 76)
@@ -0,0 +1,76 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace multi_read_unit {
+namespace read_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    XML xml ("read_unit");
+
+    xml.balise_open("read_unit");
+    xml.singleton_begin("size_read_queue         "); xml.attribut("value",toString(_size_read_queue         )); xml.singleton_end();
+    xml.singleton_begin("size_reservation_station"); xml.attribut("value",toString(_size_reservation_station)); xml.singleton_end();
+    xml.singleton_begin("nb_context              "); xml.attribut("value",toString(_nb_context              )); xml.singleton_end();
+    xml.singleton_begin("nb_front_end            "); xml.attribut("value",toString(_nb_front_end            )); xml.singleton_end();
+    xml.singleton_begin("nb_ooo_engine           "); xml.attribut("value",toString(_nb_ooo_engine           )); xml.singleton_end();
+    xml.singleton_begin("nb_packet               "); xml.attribut("value",toString(_nb_packet               )); xml.singleton_end();
+    xml.singleton_begin("size_general_data       "); xml.attribut("value",toString(_size_general_data       )); xml.singleton_end();
+    xml.singleton_begin("size_special_data       "); xml.attribut("value",toString(_size_special_data       )); xml.singleton_end();
+    xml.singleton_begin("nb_general_register     "); xml.attribut("value",toString(_nb_general_register     )); xml.singleton_end();
+    xml.singleton_begin("nb_special_register     "); xml.attribut("value",toString(_nb_special_register     )); xml.singleton_end();
+    xml.singleton_begin("nb_operation            "); xml.attribut("value",toString(_nb_operation            )); xml.singleton_end();
+    xml.singleton_begin("nb_type                 "); xml.attribut("value",toString(_nb_type                 )); xml.singleton_end();
+    xml.singleton_begin("nb_gpr_write            "); xml.attribut("value",toString(_nb_gpr_write            )); xml.singleton_end();
+    xml.singleton_begin("nb_spr_write            "); xml.attribut("value",toString(_nb_spr_write            )); xml.singleton_end();
+    xml.singleton_begin("size_store_queue        "); xml.attribut("value",toString(_size_store_queue        )); xml.singleton_end();
+    xml.singleton_begin("size_load_queue         "); xml.attribut("value",toString(_size_load_queue         )); xml.singleton_end();
+    xml.singleton_begin("nb_inst_retire          "); xml.attribut("value",toString(_nb_inst_retire          )); xml.singleton_end();
+    xml.singleton_begin("nb_bypass_write         "); xml.attribut("value",toString(_nb_bypass_write         )); xml.singleton_end();
+    xml.singleton_begin("nb_bypass_memory        "); xml.attribut("value",toString(_nb_bypass_memory        )); xml.singleton_end();
+    xml.balise_close();
+
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Read_unit::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::Parameters & x)
+  {
+    log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+    output_stream << x.print(0);
+    
+    log_printf(FUNC,Read_unit,FUNCTION,"End");
+
+    return output_stream;
+  };
+
+}; // end namespace read_unit
+}; // end namespace multi_read_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
